// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: google/api/auth.proto

package com.google.api;

/**
 * <pre>
 * `Authentication` defines the authentication configuration for an API.
 * Example for an API targeted for external use:
 *     name: calendar.googleapis.com
 *     authentication:
 *       providers:
 *       - id: google_calendar_auth
 *         jwks_uri: https://www.googleapis.com/oauth2/v1/certs
 *         issuer: https://securetoken.google.com
 *       rules:
 *       - selector: "*"
 *         requirements:
 *           provider_id: google_calendar_auth
 * </pre>
 *
 * Protobuf type {@code google.api.Authentication}
 */
public  final class Authentication extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:google.api.Authentication)
    AuthenticationOrBuilder {
private static final long serialVersionUID = 0L;
  // Use Authentication.newBuilder() to construct.
  private Authentication(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private Authentication() {
    rules_ = java.util.Collections.emptyList();
    providers_ = java.util.Collections.emptyList();
  }

  @java.lang.Override
  public final com.google.protobuf.UnknownFieldSet
  getUnknownFields() {
    return this.unknownFields;
  }
  private Authentication(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    this();
    int mutable_bitField0_ = 0;
    com.google.protobuf.UnknownFieldSet.Builder unknownFields =
        com.google.protobuf.UnknownFieldSet.newBuilder();
    try {
      boolean done = false;
      while (!done) {
        int tag = input.readTag();
        switch (tag) {
          case 0:
            done = true;
            break;
          default: {
            if (!parseUnknownFieldProto3(
                input, unknownFields, extensionRegistry, tag)) {
              done = true;
            }
            break;
          }
          case 26: {
            if (!((mutable_bitField0_ & 0x00000001) == 0x00000001)) {
              rules_ = new java.util.ArrayList<com.google.api.AuthenticationRule>();
              mutable_bitField0_ |= 0x00000001;
            }
            rules_.add(
                input.readMessage(com.google.api.AuthenticationRule.parser(), extensionRegistry));
            break;
          }
          case 34: {
            if (!((mutable_bitField0_ & 0x00000002) == 0x00000002)) {
              providers_ = new java.util.ArrayList<com.google.api.AuthProvider>();
              mutable_bitField0_ |= 0x00000002;
            }
            providers_.add(
                input.readMessage(com.google.api.AuthProvider.parser(), extensionRegistry));
            break;
          }
        }
      }
    } catch (com.google.protobuf.InvalidProtocolBufferException e) {
      throw e.setUnfinishedMessage(this);
    } catch (java.io.IOException e) {
      throw new com.google.protobuf.InvalidProtocolBufferException(
          e).setUnfinishedMessage(this);
    } finally {
      if (((mutable_bitField0_ & 0x00000001) == 0x00000001)) {
        rules_ = java.util.Collections.unmodifiableList(rules_);
      }
      if (((mutable_bitField0_ & 0x00000002) == 0x00000002)) {
        providers_ = java.util.Collections.unmodifiableList(providers_);
      }
      this.unknownFields = unknownFields.build();
      makeExtensionsImmutable();
    }
  }
  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return com.google.api.AuthProto.internal_static_google_api_Authentication_descriptor;
  }

  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return com.google.api.AuthProto.internal_static_google_api_Authentication_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            com.google.api.Authentication.class, com.google.api.Authentication.Builder.class);
  }

  public static final int RULES_FIELD_NUMBER = 3;
  private java.util.List<com.google.api.AuthenticationRule> rules_;
  /**
   * <pre>
   * A list of authentication rules that apply to individual API methods.
   * **NOTE:** All service configuration rules follow "last one wins" order.
   * </pre>
   *
   * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
   */
  public java.util.List<com.google.api.AuthenticationRule> getRulesList() {
    return rules_;
  }
  /**
   * <pre>
   * A list of authentication rules that apply to individual API methods.
   * **NOTE:** All service configuration rules follow "last one wins" order.
   * </pre>
   *
   * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
   */
  public java.util.List<? extends com.google.api.AuthenticationRuleOrBuilder> 
      getRulesOrBuilderList() {
    return rules_;
  }
  /**
   * <pre>
   * A list of authentication rules that apply to individual API methods.
   * **NOTE:** All service configuration rules follow "last one wins" order.
   * </pre>
   *
   * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
   */
  public int getRulesCount() {
    return rules_.size();
  }
  /**
   * <pre>
   * A list of authentication rules that apply to individual API methods.
   * **NOTE:** All service configuration rules follow "last one wins" order.
   * </pre>
   *
   * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
   */
  public com.google.api.AuthenticationRule getRules(int index) {
    return rules_.get(index);
  }
  /**
   * <pre>
   * A list of authentication rules that apply to individual API methods.
   * **NOTE:** All service configuration rules follow "last one wins" order.
   * </pre>
   *
   * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
   */
  public com.google.api.AuthenticationRuleOrBuilder getRulesOrBuilder(
      int index) {
    return rules_.get(index);
  }

  public static final int PROVIDERS_FIELD_NUMBER = 4;
  private java.util.List<com.google.api.AuthProvider> providers_;
  /**
   * <pre>
   * Defines a set of authentication providers that a service supports.
   * </pre>
   *
   * <code>repeated .google.api.AuthProvider providers = 4;</code>
   */
  public java.util.List<com.google.api.AuthProvider> getProvidersList() {
    return providers_;
  }
  /**
   * <pre>
   * Defines a set of authentication providers that a service supports.
   * </pre>
   *
   * <code>repeated .google.api.AuthProvider providers = 4;</code>
   */
  public java.util.List<? extends com.google.api.AuthProviderOrBuilder> 
      getProvidersOrBuilderList() {
    return providers_;
  }
  /**
   * <pre>
   * Defines a set of authentication providers that a service supports.
   * </pre>
   *
   * <code>repeated .google.api.AuthProvider providers = 4;</code>
   */
  public int getProvidersCount() {
    return providers_.size();
  }
  /**
   * <pre>
   * Defines a set of authentication providers that a service supports.
   * </pre>
   *
   * <code>repeated .google.api.AuthProvider providers = 4;</code>
   */
  public com.google.api.AuthProvider getProviders(int index) {
    return providers_.get(index);
  }
  /**
   * <pre>
   * Defines a set of authentication providers that a service supports.
   * </pre>
   *
   * <code>repeated .google.api.AuthProvider providers = 4;</code>
   */
  public com.google.api.AuthProviderOrBuilder getProvidersOrBuilder(
      int index) {
    return providers_.get(index);
  }

  private byte memoizedIsInitialized = -1;
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    for (int i = 0; i < rules_.size(); i++) {
      output.writeMessage(3, rules_.get(i));
    }
    for (int i = 0; i < providers_.size(); i++) {
      output.writeMessage(4, providers_.get(i));
    }
    unknownFields.writeTo(output);
  }

  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    for (int i = 0; i < rules_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, rules_.get(i));
    }
    for (int i = 0; i < providers_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(4, providers_.get(i));
    }
    size += unknownFields.getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof com.google.api.Authentication)) {
      return super.equals(obj);
    }
    com.google.api.Authentication other = (com.google.api.Authentication) obj;

    boolean result = true;
    result = result && getRulesList()
        .equals(other.getRulesList());
    result = result && getProvidersList()
        .equals(other.getProvidersList());
    result = result && unknownFields.equals(other.unknownFields);
    return result;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (getRulesCount() > 0) {
      hash = (37 * hash) + RULES_FIELD_NUMBER;
      hash = (53 * hash) + getRulesList().hashCode();
    }
    if (getProvidersCount() > 0) {
      hash = (37 * hash) + PROVIDERS_FIELD_NUMBER;
      hash = (53 * hash) + getProvidersList().hashCode();
    }
    hash = (29 * hash) + unknownFields.hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static com.google.api.Authentication parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.google.api.Authentication parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.google.api.Authentication parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.google.api.Authentication parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.google.api.Authentication parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.google.api.Authentication parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.google.api.Authentication parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static com.google.api.Authentication parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static com.google.api.Authentication parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static com.google.api.Authentication parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static com.google.api.Authentication parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static com.google.api.Authentication parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(com.google.api.Authentication prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * `Authentication` defines the authentication configuration for an API.
   * Example for an API targeted for external use:
   *     name: calendar.googleapis.com
   *     authentication:
   *       providers:
   *       - id: google_calendar_auth
   *         jwks_uri: https://www.googleapis.com/oauth2/v1/certs
   *         issuer: https://securetoken.google.com
   *       rules:
   *       - selector: "*"
   *         requirements:
   *           provider_id: google_calendar_auth
   * </pre>
   *
   * Protobuf type {@code google.api.Authentication}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:google.api.Authentication)
      com.google.api.AuthenticationOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.google.api.AuthProto.internal_static_google_api_Authentication_descriptor;
    }

    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.api.AuthProto.internal_static_google_api_Authentication_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.api.Authentication.class, com.google.api.Authentication.Builder.class);
    }

    // Construct using com.google.api.Authentication.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }
    private void maybeForceBuilderInitialization() {
      if (com.google.protobuf.GeneratedMessageV3
              .alwaysUseFieldBuilders) {
        getRulesFieldBuilder();
        getProvidersFieldBuilder();
      }
    }
    public Builder clear() {
      super.clear();
      if (rulesBuilder_ == null) {
        rules_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000001);
      } else {
        rulesBuilder_.clear();
      }
      if (providersBuilder_ == null) {
        providers_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000002);
      } else {
        providersBuilder_.clear();
      }
      return this;
    }

    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return com.google.api.AuthProto.internal_static_google_api_Authentication_descriptor;
    }

    public com.google.api.Authentication getDefaultInstanceForType() {
      return com.google.api.Authentication.getDefaultInstance();
    }

    public com.google.api.Authentication build() {
      com.google.api.Authentication result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    public com.google.api.Authentication buildPartial() {
      com.google.api.Authentication result = new com.google.api.Authentication(this);
      int from_bitField0_ = bitField0_;
      if (rulesBuilder_ == null) {
        if (((bitField0_ & 0x00000001) == 0x00000001)) {
          rules_ = java.util.Collections.unmodifiableList(rules_);
          bitField0_ = (bitField0_ & ~0x00000001);
        }
        result.rules_ = rules_;
      } else {
        result.rules_ = rulesBuilder_.build();
      }
      if (providersBuilder_ == null) {
        if (((bitField0_ & 0x00000002) == 0x00000002)) {
          providers_ = java.util.Collections.unmodifiableList(providers_);
          bitField0_ = (bitField0_ & ~0x00000002);
        }
        result.providers_ = providers_;
      } else {
        result.providers_ = providersBuilder_.build();
      }
      onBuilt();
      return result;
    }

    public Builder clone() {
      return (Builder) super.clone();
    }
    public Builder setField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        java.lang.Object value) {
      return (Builder) super.setField(field, value);
    }
    public Builder clearField(
        com.google.protobuf.Descriptors.FieldDescriptor field) {
      return (Builder) super.clearField(field);
    }
    public Builder clearOneof(
        com.google.protobuf.Descriptors.OneofDescriptor oneof) {
      return (Builder) super.clearOneof(oneof);
    }
    public Builder setRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        int index, java.lang.Object value) {
      return (Builder) super.setRepeatedField(field, index, value);
    }
    public Builder addRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        java.lang.Object value) {
      return (Builder) super.addRepeatedField(field, value);
    }
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof com.google.api.Authentication) {
        return mergeFrom((com.google.api.Authentication)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(com.google.api.Authentication other) {
      if (other == com.google.api.Authentication.getDefaultInstance()) return this;
      if (rulesBuilder_ == null) {
        if (!other.rules_.isEmpty()) {
          if (rules_.isEmpty()) {
            rules_ = other.rules_;
            bitField0_ = (bitField0_ & ~0x00000001);
          } else {
            ensureRulesIsMutable();
            rules_.addAll(other.rules_);
          }
          onChanged();
        }
      } else {
        if (!other.rules_.isEmpty()) {
          if (rulesBuilder_.isEmpty()) {
            rulesBuilder_.dispose();
            rulesBuilder_ = null;
            rules_ = other.rules_;
            bitField0_ = (bitField0_ & ~0x00000001);
            rulesBuilder_ = 
              com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                 getRulesFieldBuilder() : null;
          } else {
            rulesBuilder_.addAllMessages(other.rules_);
          }
        }
      }
      if (providersBuilder_ == null) {
        if (!other.providers_.isEmpty()) {
          if (providers_.isEmpty()) {
            providers_ = other.providers_;
            bitField0_ = (bitField0_ & ~0x00000002);
          } else {
            ensureProvidersIsMutable();
            providers_.addAll(other.providers_);
          }
          onChanged();
        }
      } else {
        if (!other.providers_.isEmpty()) {
          if (providersBuilder_.isEmpty()) {
            providersBuilder_.dispose();
            providersBuilder_ = null;
            providers_ = other.providers_;
            bitField0_ = (bitField0_ & ~0x00000002);
            providersBuilder_ = 
              com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                 getProvidersFieldBuilder() : null;
          } else {
            providersBuilder_.addAllMessages(other.providers_);
          }
        }
      }
      this.mergeUnknownFields(other.unknownFields);
      onChanged();
      return this;
    }

    public final boolean isInitialized() {
      return true;
    }

    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      com.google.api.Authentication parsedMessage = null;
      try {
        parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        parsedMessage = (com.google.api.Authentication) e.getUnfinishedMessage();
        throw e.unwrapIOException();
      } finally {
        if (parsedMessage != null) {
          mergeFrom(parsedMessage);
        }
      }
      return this;
    }
    private int bitField0_;

    private java.util.List<com.google.api.AuthenticationRule> rules_ =
      java.util.Collections.emptyList();
    private void ensureRulesIsMutable() {
      if (!((bitField0_ & 0x00000001) == 0x00000001)) {
        rules_ = new java.util.ArrayList<com.google.api.AuthenticationRule>(rules_);
        bitField0_ |= 0x00000001;
       }
    }

    private com.google.protobuf.RepeatedFieldBuilderV3<
        com.google.api.AuthenticationRule, com.google.api.AuthenticationRule.Builder, com.google.api.AuthenticationRuleOrBuilder> rulesBuilder_;

    /**
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public java.util.List<com.google.api.AuthenticationRule> getRulesList() {
      if (rulesBuilder_ == null) {
        return java.util.Collections.unmodifiableList(rules_);
      } else {
        return rulesBuilder_.getMessageList();
      }
    }
    /**
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public int getRulesCount() {
      if (rulesBuilder_ == null) {
        return rules_.size();
      } else {
        return rulesBuilder_.getCount();
      }
    }
    /**
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public com.google.api.AuthenticationRule getRules(int index) {
      if (rulesBuilder_ == null) {
        return rules_.get(index);
      } else {
        return rulesBuilder_.getMessage(index);
      }
    }
    /**
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public Builder setRules(
        int index, com.google.api.AuthenticationRule value) {
      if (rulesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureRulesIsMutable();
        rules_.set(index, value);
        onChanged();
      } else {
        rulesBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public Builder setRules(
        int index, com.google.api.AuthenticationRule.Builder builderForValue) {
      if (rulesBuilder_ == null) {
        ensureRulesIsMutable();
        rules_.set(index, builderForValue.build());
        onChanged();
      } else {
        rulesBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public Builder addRules(com.google.api.AuthenticationRule value) {
      if (rulesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureRulesIsMutable();
        rules_.add(value);
        onChanged();
      } else {
        rulesBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public Builder addRules(
        int index, com.google.api.AuthenticationRule value) {
      if (rulesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureRulesIsMutable();
        rules_.add(index, value);
        onChanged();
      } else {
        rulesBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public Builder addRules(
        com.google.api.AuthenticationRule.Builder builderForValue) {
      if (rulesBuilder_ == null) {
        ensureRulesIsMutable();
        rules_.add(builderForValue.build());
        onChanged();
      } else {
        rulesBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public Builder addRules(
        int index, com.google.api.AuthenticationRule.Builder builderForValue) {
      if (rulesBuilder_ == null) {
        ensureRulesIsMutable();
        rules_.add(index, builderForValue.build());
        onChanged();
      } else {
        rulesBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public Builder addAllRules(
        java.lang.Iterable<? extends com.google.api.AuthenticationRule> values) {
      if (rulesBuilder_ == null) {
        ensureRulesIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(
            values, rules_);
        onChanged();
      } else {
        rulesBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public Builder clearRules() {
      if (rulesBuilder_ == null) {
        rules_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000001);
        onChanged();
      } else {
        rulesBuilder_.clear();
      }
      return this;
    }
    /**
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public Builder removeRules(int index) {
      if (rulesBuilder_ == null) {
        ensureRulesIsMutable();
        rules_.remove(index);
        onChanged();
      } else {
        rulesBuilder_.remove(index);
      }
      return this;
    }
    /**
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public com.google.api.AuthenticationRule.Builder getRulesBuilder(
        int index) {
      return getRulesFieldBuilder().getBuilder(index);
    }
    /**
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public com.google.api.AuthenticationRuleOrBuilder getRulesOrBuilder(
        int index) {
      if (rulesBuilder_ == null) {
        return rules_.get(index);  } else {
        return rulesBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public java.util.List<? extends com.google.api.AuthenticationRuleOrBuilder> 
         getRulesOrBuilderList() {
      if (rulesBuilder_ != null) {
        return rulesBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(rules_);
      }
    }
    /**
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public com.google.api.AuthenticationRule.Builder addRulesBuilder() {
      return getRulesFieldBuilder().addBuilder(
          com.google.api.AuthenticationRule.getDefaultInstance());
    }
    /**
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public com.google.api.AuthenticationRule.Builder addRulesBuilder(
        int index) {
      return getRulesFieldBuilder().addBuilder(
          index, com.google.api.AuthenticationRule.getDefaultInstance());
    }
    /**
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public java.util.List<com.google.api.AuthenticationRule.Builder> 
         getRulesBuilderList() {
      return getRulesFieldBuilder().getBuilderList();
    }
    private com.google.protobuf.RepeatedFieldBuilderV3<
        com.google.api.AuthenticationRule, com.google.api.AuthenticationRule.Builder, com.google.api.AuthenticationRuleOrBuilder> 
        getRulesFieldBuilder() {
      if (rulesBuilder_ == null) {
        rulesBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
            com.google.api.AuthenticationRule, com.google.api.AuthenticationRule.Builder, com.google.api.AuthenticationRuleOrBuilder>(
                rules_,
                ((bitField0_ & 0x00000001) == 0x00000001),
                getParentForChildren(),
                isClean());
        rules_ = null;
      }
      return rulesBuilder_;
    }

    private java.util.List<com.google.api.AuthProvider> providers_ =
      java.util.Collections.emptyList();
    private void ensureProvidersIsMutable() {
      if (!((bitField0_ & 0x00000002) == 0x00000002)) {
        providers_ = new java.util.ArrayList<com.google.api.AuthProvider>(providers_);
        bitField0_ |= 0x00000002;
       }
    }

    private com.google.protobuf.RepeatedFieldBuilderV3<
        com.google.api.AuthProvider, com.google.api.AuthProvider.Builder, com.google.api.AuthProviderOrBuilder> providersBuilder_;

    /**
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public java.util.List<com.google.api.AuthProvider> getProvidersList() {
      if (providersBuilder_ == null) {
        return java.util.Collections.unmodifiableList(providers_);
      } else {
        return providersBuilder_.getMessageList();
      }
    }
    /**
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public int getProvidersCount() {
      if (providersBuilder_ == null) {
        return providers_.size();
      } else {
        return providersBuilder_.getCount();
      }
    }
    /**
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public com.google.api.AuthProvider getProviders(int index) {
      if (providersBuilder_ == null) {
        return providers_.get(index);
      } else {
        return providersBuilder_.getMessage(index);
      }
    }
    /**
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public Builder setProviders(
        int index, com.google.api.AuthProvider value) {
      if (providersBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureProvidersIsMutable();
        providers_.set(index, value);
        onChanged();
      } else {
        providersBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public Builder setProviders(
        int index, com.google.api.AuthProvider.Builder builderForValue) {
      if (providersBuilder_ == null) {
        ensureProvidersIsMutable();
        providers_.set(index, builderForValue.build());
        onChanged();
      } else {
        providersBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public Builder addProviders(com.google.api.AuthProvider value) {
      if (providersBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureProvidersIsMutable();
        providers_.add(value);
        onChanged();
      } else {
        providersBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public Builder addProviders(
        int index, com.google.api.AuthProvider value) {
      if (providersBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureProvidersIsMutable();
        providers_.add(index, value);
        onChanged();
      } else {
        providersBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public Builder addProviders(
        com.google.api.AuthProvider.Builder builderForValue) {
      if (providersBuilder_ == null) {
        ensureProvidersIsMutable();
        providers_.add(builderForValue.build());
        onChanged();
      } else {
        providersBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public Builder addProviders(
        int index, com.google.api.AuthProvider.Builder builderForValue) {
      if (providersBuilder_ == null) {
        ensureProvidersIsMutable();
        providers_.add(index, builderForValue.build());
        onChanged();
      } else {
        providersBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public Builder addAllProviders(
        java.lang.Iterable<? extends com.google.api.AuthProvider> values) {
      if (providersBuilder_ == null) {
        ensureProvidersIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(
            values, providers_);
        onChanged();
      } else {
        providersBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public Builder clearProviders() {
      if (providersBuilder_ == null) {
        providers_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000002);
        onChanged();
      } else {
        providersBuilder_.clear();
      }
      return this;
    }
    /**
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public Builder removeProviders(int index) {
      if (providersBuilder_ == null) {
        ensureProvidersIsMutable();
        providers_.remove(index);
        onChanged();
      } else {
        providersBuilder_.remove(index);
      }
      return this;
    }
    /**
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public com.google.api.AuthProvider.Builder getProvidersBuilder(
        int index) {
      return getProvidersFieldBuilder().getBuilder(index);
    }
    /**
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public com.google.api.AuthProviderOrBuilder getProvidersOrBuilder(
        int index) {
      if (providersBuilder_ == null) {
        return providers_.get(index);  } else {
        return providersBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public java.util.List<? extends com.google.api.AuthProviderOrBuilder> 
         getProvidersOrBuilderList() {
      if (providersBuilder_ != null) {
        return providersBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(providers_);
      }
    }
    /**
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public com.google.api.AuthProvider.Builder addProvidersBuilder() {
      return getProvidersFieldBuilder().addBuilder(
          com.google.api.AuthProvider.getDefaultInstance());
    }
    /**
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public com.google.api.AuthProvider.Builder addProvidersBuilder(
        int index) {
      return getProvidersFieldBuilder().addBuilder(
          index, com.google.api.AuthProvider.getDefaultInstance());
    }
    /**
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public java.util.List<com.google.api.AuthProvider.Builder> 
         getProvidersBuilderList() {
      return getProvidersFieldBuilder().getBuilderList();
    }
    private com.google.protobuf.RepeatedFieldBuilderV3<
        com.google.api.AuthProvider, com.google.api.AuthProvider.Builder, com.google.api.AuthProviderOrBuilder> 
        getProvidersFieldBuilder() {
      if (providersBuilder_ == null) {
        providersBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
            com.google.api.AuthProvider, com.google.api.AuthProvider.Builder, com.google.api.AuthProviderOrBuilder>(
                providers_,
                ((bitField0_ & 0x00000002) == 0x00000002),
                getParentForChildren(),
                isClean());
        providers_ = null;
      }
      return providersBuilder_;
    }
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFieldsProto3(unknownFields);
    }

    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:google.api.Authentication)
  }

  // @@protoc_insertion_point(class_scope:google.api.Authentication)
  private static final com.google.api.Authentication DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new com.google.api.Authentication();
  }

  public static com.google.api.Authentication getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<Authentication>
      PARSER = new com.google.protobuf.AbstractParser<Authentication>() {
    public Authentication parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
        return new Authentication(input, extensionRegistry);
    }
  };

  public static com.google.protobuf.Parser<Authentication> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<Authentication> getParserForType() {
    return PARSER;
  }

  public com.google.api.Authentication getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

