// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: google/devtools/remoteexecution/v1test/remote_execution.proto

package com.google.devtools.remoteexecution.v1test;

/**
 * <pre>
 * A `Directory` represents a directory node in a file tree, containing zero or
 * more children [FileNodes][google.devtools.remoteexecution.v1test.FileNode]
 * and [DirectoryNodes][google.devtools.remoteexecution.v1test.DirectoryNode].
 * Each `Node` contains its name in the directory, the digest of its content
 * (either a file blob or a `Directory` proto), as well as possibly some
 * metadata about the file or directory.
 * In order to ensure that two equivalent directory trees hash to the same
 * value, the following restrictions MUST be obeyed when constructing a
 * a `Directory`:
 *   - Every child in the directory must have a path of exactly one segment.
 *     Multiple levels of directory hierarchy may not be collapsed.
 *   - Each child in the directory must have a unique path segment (file name).
 *   - The files and directories in the directory must each be sorted in
 *     lexicographical order by path. The path strings must be sorted by code
 *     point, equivalently, by UTF-8 bytes.
 * A `Directory` that obeys the restrictions is said to be in canonical form.
 * As an example, the following could be used for a file named `bar` and a
 * directory named `foo` with an executable file named `baz` (hashes shortened
 * for readability):
 * ```json
 * // (Directory proto)
 * {
 *   files: [
 *     {
 *       name: "bar",
 *       digest: {
 *         hash: "4a73bc9d03...",
 *         size: 65534
 *       }
 *     }
 *   ],
 *   directories: [
 *     {
 *       name: "foo",
 *       digest: {
 *         hash: "4cf2eda940...",
 *         size: 43
 *       }
 *     }
 *   ]
 * }
 * // (Directory proto with hash "4cf2eda940..." and size 43)
 * {
 *   files: [
 *     {
 *       name: "baz",
 *       digest: {
 *         hash: "b2c941073e...",
 *         size: 1294,
 *       },
 *       is_executable: true
 *     }
 *   ]
 * }
 * ```
 * </pre>
 *
 * Protobuf type {@code google.devtools.remoteexecution.v1test.Directory}
 */
public  final class Directory extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:google.devtools.remoteexecution.v1test.Directory)
    DirectoryOrBuilder {
private static final long serialVersionUID = 0L;
  // Use Directory.newBuilder() to construct.
  private Directory(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private Directory() {
    files_ = java.util.Collections.emptyList();
    directories_ = java.util.Collections.emptyList();
  }

  @java.lang.Override
  public final com.google.protobuf.UnknownFieldSet
  getUnknownFields() {
    return this.unknownFields;
  }
  private Directory(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    this();
    int mutable_bitField0_ = 0;
    com.google.protobuf.UnknownFieldSet.Builder unknownFields =
        com.google.protobuf.UnknownFieldSet.newBuilder();
    try {
      boolean done = false;
      while (!done) {
        int tag = input.readTag();
        switch (tag) {
          case 0:
            done = true;
            break;
          default: {
            if (!parseUnknownFieldProto3(
                input, unknownFields, extensionRegistry, tag)) {
              done = true;
            }
            break;
          }
          case 10: {
            if (!((mutable_bitField0_ & 0x00000001) == 0x00000001)) {
              files_ = new java.util.ArrayList<com.google.devtools.remoteexecution.v1test.FileNode>();
              mutable_bitField0_ |= 0x00000001;
            }
            files_.add(
                input.readMessage(com.google.devtools.remoteexecution.v1test.FileNode.parser(), extensionRegistry));
            break;
          }
          case 18: {
            if (!((mutable_bitField0_ & 0x00000002) == 0x00000002)) {
              directories_ = new java.util.ArrayList<com.google.devtools.remoteexecution.v1test.DirectoryNode>();
              mutable_bitField0_ |= 0x00000002;
            }
            directories_.add(
                input.readMessage(com.google.devtools.remoteexecution.v1test.DirectoryNode.parser(), extensionRegistry));
            break;
          }
        }
      }
    } catch (com.google.protobuf.InvalidProtocolBufferException e) {
      throw e.setUnfinishedMessage(this);
    } catch (java.io.IOException e) {
      throw new com.google.protobuf.InvalidProtocolBufferException(
          e).setUnfinishedMessage(this);
    } finally {
      if (((mutable_bitField0_ & 0x00000001) == 0x00000001)) {
        files_ = java.util.Collections.unmodifiableList(files_);
      }
      if (((mutable_bitField0_ & 0x00000002) == 0x00000002)) {
        directories_ = java.util.Collections.unmodifiableList(directories_);
      }
      this.unknownFields = unknownFields.build();
      makeExtensionsImmutable();
    }
  }
  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return com.google.devtools.remoteexecution.v1test.RemoteExecutionProto.internal_static_google_devtools_remoteexecution_v1test_Directory_descriptor;
  }

  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return com.google.devtools.remoteexecution.v1test.RemoteExecutionProto.internal_static_google_devtools_remoteexecution_v1test_Directory_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            com.google.devtools.remoteexecution.v1test.Directory.class, com.google.devtools.remoteexecution.v1test.Directory.Builder.class);
  }

  public static final int FILES_FIELD_NUMBER = 1;
  private java.util.List<com.google.devtools.remoteexecution.v1test.FileNode> files_;
  /**
   * <pre>
   * The files in the directory.
   * </pre>
   *
   * <code>repeated .google.devtools.remoteexecution.v1test.FileNode files = 1;</code>
   */
  public java.util.List<com.google.devtools.remoteexecution.v1test.FileNode> getFilesList() {
    return files_;
  }
  /**
   * <pre>
   * The files in the directory.
   * </pre>
   *
   * <code>repeated .google.devtools.remoteexecution.v1test.FileNode files = 1;</code>
   */
  public java.util.List<? extends com.google.devtools.remoteexecution.v1test.FileNodeOrBuilder> 
      getFilesOrBuilderList() {
    return files_;
  }
  /**
   * <pre>
   * The files in the directory.
   * </pre>
   *
   * <code>repeated .google.devtools.remoteexecution.v1test.FileNode files = 1;</code>
   */
  public int getFilesCount() {
    return files_.size();
  }
  /**
   * <pre>
   * The files in the directory.
   * </pre>
   *
   * <code>repeated .google.devtools.remoteexecution.v1test.FileNode files = 1;</code>
   */
  public com.google.devtools.remoteexecution.v1test.FileNode getFiles(int index) {
    return files_.get(index);
  }
  /**
   * <pre>
   * The files in the directory.
   * </pre>
   *
   * <code>repeated .google.devtools.remoteexecution.v1test.FileNode files = 1;</code>
   */
  public com.google.devtools.remoteexecution.v1test.FileNodeOrBuilder getFilesOrBuilder(
      int index) {
    return files_.get(index);
  }

  public static final int DIRECTORIES_FIELD_NUMBER = 2;
  private java.util.List<com.google.devtools.remoteexecution.v1test.DirectoryNode> directories_;
  /**
   * <pre>
   * The subdirectories in the directory.
   * </pre>
   *
   * <code>repeated .google.devtools.remoteexecution.v1test.DirectoryNode directories = 2;</code>
   */
  public java.util.List<com.google.devtools.remoteexecution.v1test.DirectoryNode> getDirectoriesList() {
    return directories_;
  }
  /**
   * <pre>
   * The subdirectories in the directory.
   * </pre>
   *
   * <code>repeated .google.devtools.remoteexecution.v1test.DirectoryNode directories = 2;</code>
   */
  public java.util.List<? extends com.google.devtools.remoteexecution.v1test.DirectoryNodeOrBuilder> 
      getDirectoriesOrBuilderList() {
    return directories_;
  }
  /**
   * <pre>
   * The subdirectories in the directory.
   * </pre>
   *
   * <code>repeated .google.devtools.remoteexecution.v1test.DirectoryNode directories = 2;</code>
   */
  public int getDirectoriesCount() {
    return directories_.size();
  }
  /**
   * <pre>
   * The subdirectories in the directory.
   * </pre>
   *
   * <code>repeated .google.devtools.remoteexecution.v1test.DirectoryNode directories = 2;</code>
   */
  public com.google.devtools.remoteexecution.v1test.DirectoryNode getDirectories(int index) {
    return directories_.get(index);
  }
  /**
   * <pre>
   * The subdirectories in the directory.
   * </pre>
   *
   * <code>repeated .google.devtools.remoteexecution.v1test.DirectoryNode directories = 2;</code>
   */
  public com.google.devtools.remoteexecution.v1test.DirectoryNodeOrBuilder getDirectoriesOrBuilder(
      int index) {
    return directories_.get(index);
  }

  private byte memoizedIsInitialized = -1;
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    for (int i = 0; i < files_.size(); i++) {
      output.writeMessage(1, files_.get(i));
    }
    for (int i = 0; i < directories_.size(); i++) {
      output.writeMessage(2, directories_.get(i));
    }
    unknownFields.writeTo(output);
  }

  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    for (int i = 0; i < files_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, files_.get(i));
    }
    for (int i = 0; i < directories_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, directories_.get(i));
    }
    size += unknownFields.getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof com.google.devtools.remoteexecution.v1test.Directory)) {
      return super.equals(obj);
    }
    com.google.devtools.remoteexecution.v1test.Directory other = (com.google.devtools.remoteexecution.v1test.Directory) obj;

    boolean result = true;
    result = result && getFilesList()
        .equals(other.getFilesList());
    result = result && getDirectoriesList()
        .equals(other.getDirectoriesList());
    result = result && unknownFields.equals(other.unknownFields);
    return result;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (getFilesCount() > 0) {
      hash = (37 * hash) + FILES_FIELD_NUMBER;
      hash = (53 * hash) + getFilesList().hashCode();
    }
    if (getDirectoriesCount() > 0) {
      hash = (37 * hash) + DIRECTORIES_FIELD_NUMBER;
      hash = (53 * hash) + getDirectoriesList().hashCode();
    }
    hash = (29 * hash) + unknownFields.hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static com.google.devtools.remoteexecution.v1test.Directory parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.google.devtools.remoteexecution.v1test.Directory parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.google.devtools.remoteexecution.v1test.Directory parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.google.devtools.remoteexecution.v1test.Directory parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.google.devtools.remoteexecution.v1test.Directory parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.google.devtools.remoteexecution.v1test.Directory parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.google.devtools.remoteexecution.v1test.Directory parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static com.google.devtools.remoteexecution.v1test.Directory parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static com.google.devtools.remoteexecution.v1test.Directory parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static com.google.devtools.remoteexecution.v1test.Directory parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static com.google.devtools.remoteexecution.v1test.Directory parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static com.google.devtools.remoteexecution.v1test.Directory parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(com.google.devtools.remoteexecution.v1test.Directory prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * A `Directory` represents a directory node in a file tree, containing zero or
   * more children [FileNodes][google.devtools.remoteexecution.v1test.FileNode]
   * and [DirectoryNodes][google.devtools.remoteexecution.v1test.DirectoryNode].
   * Each `Node` contains its name in the directory, the digest of its content
   * (either a file blob or a `Directory` proto), as well as possibly some
   * metadata about the file or directory.
   * In order to ensure that two equivalent directory trees hash to the same
   * value, the following restrictions MUST be obeyed when constructing a
   * a `Directory`:
   *   - Every child in the directory must have a path of exactly one segment.
   *     Multiple levels of directory hierarchy may not be collapsed.
   *   - Each child in the directory must have a unique path segment (file name).
   *   - The files and directories in the directory must each be sorted in
   *     lexicographical order by path. The path strings must be sorted by code
   *     point, equivalently, by UTF-8 bytes.
   * A `Directory` that obeys the restrictions is said to be in canonical form.
   * As an example, the following could be used for a file named `bar` and a
   * directory named `foo` with an executable file named `baz` (hashes shortened
   * for readability):
   * ```json
   * // (Directory proto)
   * {
   *   files: [
   *     {
   *       name: "bar",
   *       digest: {
   *         hash: "4a73bc9d03...",
   *         size: 65534
   *       }
   *     }
   *   ],
   *   directories: [
   *     {
   *       name: "foo",
   *       digest: {
   *         hash: "4cf2eda940...",
   *         size: 43
   *       }
   *     }
   *   ]
   * }
   * // (Directory proto with hash "4cf2eda940..." and size 43)
   * {
   *   files: [
   *     {
   *       name: "baz",
   *       digest: {
   *         hash: "b2c941073e...",
   *         size: 1294,
   *       },
   *       is_executable: true
   *     }
   *   ]
   * }
   * ```
   * </pre>
   *
   * Protobuf type {@code google.devtools.remoteexecution.v1test.Directory}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:google.devtools.remoteexecution.v1test.Directory)
      com.google.devtools.remoteexecution.v1test.DirectoryOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.google.devtools.remoteexecution.v1test.RemoteExecutionProto.internal_static_google_devtools_remoteexecution_v1test_Directory_descriptor;
    }

    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.devtools.remoteexecution.v1test.RemoteExecutionProto.internal_static_google_devtools_remoteexecution_v1test_Directory_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.devtools.remoteexecution.v1test.Directory.class, com.google.devtools.remoteexecution.v1test.Directory.Builder.class);
    }

    // Construct using com.google.devtools.remoteexecution.v1test.Directory.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }
    private void maybeForceBuilderInitialization() {
      if (com.google.protobuf.GeneratedMessageV3
              .alwaysUseFieldBuilders) {
        getFilesFieldBuilder();
        getDirectoriesFieldBuilder();
      }
    }
    public Builder clear() {
      super.clear();
      if (filesBuilder_ == null) {
        files_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000001);
      } else {
        filesBuilder_.clear();
      }
      if (directoriesBuilder_ == null) {
        directories_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000002);
      } else {
        directoriesBuilder_.clear();
      }
      return this;
    }

    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return com.google.devtools.remoteexecution.v1test.RemoteExecutionProto.internal_static_google_devtools_remoteexecution_v1test_Directory_descriptor;
    }

    public com.google.devtools.remoteexecution.v1test.Directory getDefaultInstanceForType() {
      return com.google.devtools.remoteexecution.v1test.Directory.getDefaultInstance();
    }

    public com.google.devtools.remoteexecution.v1test.Directory build() {
      com.google.devtools.remoteexecution.v1test.Directory result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    public com.google.devtools.remoteexecution.v1test.Directory buildPartial() {
      com.google.devtools.remoteexecution.v1test.Directory result = new com.google.devtools.remoteexecution.v1test.Directory(this);
      int from_bitField0_ = bitField0_;
      if (filesBuilder_ == null) {
        if (((bitField0_ & 0x00000001) == 0x00000001)) {
          files_ = java.util.Collections.unmodifiableList(files_);
          bitField0_ = (bitField0_ & ~0x00000001);
        }
        result.files_ = files_;
      } else {
        result.files_ = filesBuilder_.build();
      }
      if (directoriesBuilder_ == null) {
        if (((bitField0_ & 0x00000002) == 0x00000002)) {
          directories_ = java.util.Collections.unmodifiableList(directories_);
          bitField0_ = (bitField0_ & ~0x00000002);
        }
        result.directories_ = directories_;
      } else {
        result.directories_ = directoriesBuilder_.build();
      }
      onBuilt();
      return result;
    }

    public Builder clone() {
      return (Builder) super.clone();
    }
    public Builder setField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        java.lang.Object value) {
      return (Builder) super.setField(field, value);
    }
    public Builder clearField(
        com.google.protobuf.Descriptors.FieldDescriptor field) {
      return (Builder) super.clearField(field);
    }
    public Builder clearOneof(
        com.google.protobuf.Descriptors.OneofDescriptor oneof) {
      return (Builder) super.clearOneof(oneof);
    }
    public Builder setRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        int index, java.lang.Object value) {
      return (Builder) super.setRepeatedField(field, index, value);
    }
    public Builder addRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        java.lang.Object value) {
      return (Builder) super.addRepeatedField(field, value);
    }
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof com.google.devtools.remoteexecution.v1test.Directory) {
        return mergeFrom((com.google.devtools.remoteexecution.v1test.Directory)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(com.google.devtools.remoteexecution.v1test.Directory other) {
      if (other == com.google.devtools.remoteexecution.v1test.Directory.getDefaultInstance()) return this;
      if (filesBuilder_ == null) {
        if (!other.files_.isEmpty()) {
          if (files_.isEmpty()) {
            files_ = other.files_;
            bitField0_ = (bitField0_ & ~0x00000001);
          } else {
            ensureFilesIsMutable();
            files_.addAll(other.files_);
          }
          onChanged();
        }
      } else {
        if (!other.files_.isEmpty()) {
          if (filesBuilder_.isEmpty()) {
            filesBuilder_.dispose();
            filesBuilder_ = null;
            files_ = other.files_;
            bitField0_ = (bitField0_ & ~0x00000001);
            filesBuilder_ = 
              com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                 getFilesFieldBuilder() : null;
          } else {
            filesBuilder_.addAllMessages(other.files_);
          }
        }
      }
      if (directoriesBuilder_ == null) {
        if (!other.directories_.isEmpty()) {
          if (directories_.isEmpty()) {
            directories_ = other.directories_;
            bitField0_ = (bitField0_ & ~0x00000002);
          } else {
            ensureDirectoriesIsMutable();
            directories_.addAll(other.directories_);
          }
          onChanged();
        }
      } else {
        if (!other.directories_.isEmpty()) {
          if (directoriesBuilder_.isEmpty()) {
            directoriesBuilder_.dispose();
            directoriesBuilder_ = null;
            directories_ = other.directories_;
            bitField0_ = (bitField0_ & ~0x00000002);
            directoriesBuilder_ = 
              com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                 getDirectoriesFieldBuilder() : null;
          } else {
            directoriesBuilder_.addAllMessages(other.directories_);
          }
        }
      }
      this.mergeUnknownFields(other.unknownFields);
      onChanged();
      return this;
    }

    public final boolean isInitialized() {
      return true;
    }

    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      com.google.devtools.remoteexecution.v1test.Directory parsedMessage = null;
      try {
        parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        parsedMessage = (com.google.devtools.remoteexecution.v1test.Directory) e.getUnfinishedMessage();
        throw e.unwrapIOException();
      } finally {
        if (parsedMessage != null) {
          mergeFrom(parsedMessage);
        }
      }
      return this;
    }
    private int bitField0_;

    private java.util.List<com.google.devtools.remoteexecution.v1test.FileNode> files_ =
      java.util.Collections.emptyList();
    private void ensureFilesIsMutable() {
      if (!((bitField0_ & 0x00000001) == 0x00000001)) {
        files_ = new java.util.ArrayList<com.google.devtools.remoteexecution.v1test.FileNode>(files_);
        bitField0_ |= 0x00000001;
       }
    }

    private com.google.protobuf.RepeatedFieldBuilderV3<
        com.google.devtools.remoteexecution.v1test.FileNode, com.google.devtools.remoteexecution.v1test.FileNode.Builder, com.google.devtools.remoteexecution.v1test.FileNodeOrBuilder> filesBuilder_;

    /**
     * <pre>
     * The files in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.FileNode files = 1;</code>
     */
    public java.util.List<com.google.devtools.remoteexecution.v1test.FileNode> getFilesList() {
      if (filesBuilder_ == null) {
        return java.util.Collections.unmodifiableList(files_);
      } else {
        return filesBuilder_.getMessageList();
      }
    }
    /**
     * <pre>
     * The files in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.FileNode files = 1;</code>
     */
    public int getFilesCount() {
      if (filesBuilder_ == null) {
        return files_.size();
      } else {
        return filesBuilder_.getCount();
      }
    }
    /**
     * <pre>
     * The files in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.FileNode files = 1;</code>
     */
    public com.google.devtools.remoteexecution.v1test.FileNode getFiles(int index) {
      if (filesBuilder_ == null) {
        return files_.get(index);
      } else {
        return filesBuilder_.getMessage(index);
      }
    }
    /**
     * <pre>
     * The files in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.FileNode files = 1;</code>
     */
    public Builder setFiles(
        int index, com.google.devtools.remoteexecution.v1test.FileNode value) {
      if (filesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureFilesIsMutable();
        files_.set(index, value);
        onChanged();
      } else {
        filesBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * The files in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.FileNode files = 1;</code>
     */
    public Builder setFiles(
        int index, com.google.devtools.remoteexecution.v1test.FileNode.Builder builderForValue) {
      if (filesBuilder_ == null) {
        ensureFilesIsMutable();
        files_.set(index, builderForValue.build());
        onChanged();
      } else {
        filesBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * The files in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.FileNode files = 1;</code>
     */
    public Builder addFiles(com.google.devtools.remoteexecution.v1test.FileNode value) {
      if (filesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureFilesIsMutable();
        files_.add(value);
        onChanged();
      } else {
        filesBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     * <pre>
     * The files in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.FileNode files = 1;</code>
     */
    public Builder addFiles(
        int index, com.google.devtools.remoteexecution.v1test.FileNode value) {
      if (filesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureFilesIsMutable();
        files_.add(index, value);
        onChanged();
      } else {
        filesBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * The files in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.FileNode files = 1;</code>
     */
    public Builder addFiles(
        com.google.devtools.remoteexecution.v1test.FileNode.Builder builderForValue) {
      if (filesBuilder_ == null) {
        ensureFilesIsMutable();
        files_.add(builderForValue.build());
        onChanged();
      } else {
        filesBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * The files in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.FileNode files = 1;</code>
     */
    public Builder addFiles(
        int index, com.google.devtools.remoteexecution.v1test.FileNode.Builder builderForValue) {
      if (filesBuilder_ == null) {
        ensureFilesIsMutable();
        files_.add(index, builderForValue.build());
        onChanged();
      } else {
        filesBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * The files in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.FileNode files = 1;</code>
     */
    public Builder addAllFiles(
        java.lang.Iterable<? extends com.google.devtools.remoteexecution.v1test.FileNode> values) {
      if (filesBuilder_ == null) {
        ensureFilesIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(
            values, files_);
        onChanged();
      } else {
        filesBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     * <pre>
     * The files in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.FileNode files = 1;</code>
     */
    public Builder clearFiles() {
      if (filesBuilder_ == null) {
        files_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000001);
        onChanged();
      } else {
        filesBuilder_.clear();
      }
      return this;
    }
    /**
     * <pre>
     * The files in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.FileNode files = 1;</code>
     */
    public Builder removeFiles(int index) {
      if (filesBuilder_ == null) {
        ensureFilesIsMutable();
        files_.remove(index);
        onChanged();
      } else {
        filesBuilder_.remove(index);
      }
      return this;
    }
    /**
     * <pre>
     * The files in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.FileNode files = 1;</code>
     */
    public com.google.devtools.remoteexecution.v1test.FileNode.Builder getFilesBuilder(
        int index) {
      return getFilesFieldBuilder().getBuilder(index);
    }
    /**
     * <pre>
     * The files in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.FileNode files = 1;</code>
     */
    public com.google.devtools.remoteexecution.v1test.FileNodeOrBuilder getFilesOrBuilder(
        int index) {
      if (filesBuilder_ == null) {
        return files_.get(index);  } else {
        return filesBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     * <pre>
     * The files in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.FileNode files = 1;</code>
     */
    public java.util.List<? extends com.google.devtools.remoteexecution.v1test.FileNodeOrBuilder> 
         getFilesOrBuilderList() {
      if (filesBuilder_ != null) {
        return filesBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(files_);
      }
    }
    /**
     * <pre>
     * The files in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.FileNode files = 1;</code>
     */
    public com.google.devtools.remoteexecution.v1test.FileNode.Builder addFilesBuilder() {
      return getFilesFieldBuilder().addBuilder(
          com.google.devtools.remoteexecution.v1test.FileNode.getDefaultInstance());
    }
    /**
     * <pre>
     * The files in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.FileNode files = 1;</code>
     */
    public com.google.devtools.remoteexecution.v1test.FileNode.Builder addFilesBuilder(
        int index) {
      return getFilesFieldBuilder().addBuilder(
          index, com.google.devtools.remoteexecution.v1test.FileNode.getDefaultInstance());
    }
    /**
     * <pre>
     * The files in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.FileNode files = 1;</code>
     */
    public java.util.List<com.google.devtools.remoteexecution.v1test.FileNode.Builder> 
         getFilesBuilderList() {
      return getFilesFieldBuilder().getBuilderList();
    }
    private com.google.protobuf.RepeatedFieldBuilderV3<
        com.google.devtools.remoteexecution.v1test.FileNode, com.google.devtools.remoteexecution.v1test.FileNode.Builder, com.google.devtools.remoteexecution.v1test.FileNodeOrBuilder> 
        getFilesFieldBuilder() {
      if (filesBuilder_ == null) {
        filesBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
            com.google.devtools.remoteexecution.v1test.FileNode, com.google.devtools.remoteexecution.v1test.FileNode.Builder, com.google.devtools.remoteexecution.v1test.FileNodeOrBuilder>(
                files_,
                ((bitField0_ & 0x00000001) == 0x00000001),
                getParentForChildren(),
                isClean());
        files_ = null;
      }
      return filesBuilder_;
    }

    private java.util.List<com.google.devtools.remoteexecution.v1test.DirectoryNode> directories_ =
      java.util.Collections.emptyList();
    private void ensureDirectoriesIsMutable() {
      if (!((bitField0_ & 0x00000002) == 0x00000002)) {
        directories_ = new java.util.ArrayList<com.google.devtools.remoteexecution.v1test.DirectoryNode>(directories_);
        bitField0_ |= 0x00000002;
       }
    }

    private com.google.protobuf.RepeatedFieldBuilderV3<
        com.google.devtools.remoteexecution.v1test.DirectoryNode, com.google.devtools.remoteexecution.v1test.DirectoryNode.Builder, com.google.devtools.remoteexecution.v1test.DirectoryNodeOrBuilder> directoriesBuilder_;

    /**
     * <pre>
     * The subdirectories in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.DirectoryNode directories = 2;</code>
     */
    public java.util.List<com.google.devtools.remoteexecution.v1test.DirectoryNode> getDirectoriesList() {
      if (directoriesBuilder_ == null) {
        return java.util.Collections.unmodifiableList(directories_);
      } else {
        return directoriesBuilder_.getMessageList();
      }
    }
    /**
     * <pre>
     * The subdirectories in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.DirectoryNode directories = 2;</code>
     */
    public int getDirectoriesCount() {
      if (directoriesBuilder_ == null) {
        return directories_.size();
      } else {
        return directoriesBuilder_.getCount();
      }
    }
    /**
     * <pre>
     * The subdirectories in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.DirectoryNode directories = 2;</code>
     */
    public com.google.devtools.remoteexecution.v1test.DirectoryNode getDirectories(int index) {
      if (directoriesBuilder_ == null) {
        return directories_.get(index);
      } else {
        return directoriesBuilder_.getMessage(index);
      }
    }
    /**
     * <pre>
     * The subdirectories in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.DirectoryNode directories = 2;</code>
     */
    public Builder setDirectories(
        int index, com.google.devtools.remoteexecution.v1test.DirectoryNode value) {
      if (directoriesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureDirectoriesIsMutable();
        directories_.set(index, value);
        onChanged();
      } else {
        directoriesBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * The subdirectories in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.DirectoryNode directories = 2;</code>
     */
    public Builder setDirectories(
        int index, com.google.devtools.remoteexecution.v1test.DirectoryNode.Builder builderForValue) {
      if (directoriesBuilder_ == null) {
        ensureDirectoriesIsMutable();
        directories_.set(index, builderForValue.build());
        onChanged();
      } else {
        directoriesBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * The subdirectories in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.DirectoryNode directories = 2;</code>
     */
    public Builder addDirectories(com.google.devtools.remoteexecution.v1test.DirectoryNode value) {
      if (directoriesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureDirectoriesIsMutable();
        directories_.add(value);
        onChanged();
      } else {
        directoriesBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     * <pre>
     * The subdirectories in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.DirectoryNode directories = 2;</code>
     */
    public Builder addDirectories(
        int index, com.google.devtools.remoteexecution.v1test.DirectoryNode value) {
      if (directoriesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureDirectoriesIsMutable();
        directories_.add(index, value);
        onChanged();
      } else {
        directoriesBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * The subdirectories in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.DirectoryNode directories = 2;</code>
     */
    public Builder addDirectories(
        com.google.devtools.remoteexecution.v1test.DirectoryNode.Builder builderForValue) {
      if (directoriesBuilder_ == null) {
        ensureDirectoriesIsMutable();
        directories_.add(builderForValue.build());
        onChanged();
      } else {
        directoriesBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * The subdirectories in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.DirectoryNode directories = 2;</code>
     */
    public Builder addDirectories(
        int index, com.google.devtools.remoteexecution.v1test.DirectoryNode.Builder builderForValue) {
      if (directoriesBuilder_ == null) {
        ensureDirectoriesIsMutable();
        directories_.add(index, builderForValue.build());
        onChanged();
      } else {
        directoriesBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * The subdirectories in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.DirectoryNode directories = 2;</code>
     */
    public Builder addAllDirectories(
        java.lang.Iterable<? extends com.google.devtools.remoteexecution.v1test.DirectoryNode> values) {
      if (directoriesBuilder_ == null) {
        ensureDirectoriesIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(
            values, directories_);
        onChanged();
      } else {
        directoriesBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     * <pre>
     * The subdirectories in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.DirectoryNode directories = 2;</code>
     */
    public Builder clearDirectories() {
      if (directoriesBuilder_ == null) {
        directories_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000002);
        onChanged();
      } else {
        directoriesBuilder_.clear();
      }
      return this;
    }
    /**
     * <pre>
     * The subdirectories in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.DirectoryNode directories = 2;</code>
     */
    public Builder removeDirectories(int index) {
      if (directoriesBuilder_ == null) {
        ensureDirectoriesIsMutable();
        directories_.remove(index);
        onChanged();
      } else {
        directoriesBuilder_.remove(index);
      }
      return this;
    }
    /**
     * <pre>
     * The subdirectories in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.DirectoryNode directories = 2;</code>
     */
    public com.google.devtools.remoteexecution.v1test.DirectoryNode.Builder getDirectoriesBuilder(
        int index) {
      return getDirectoriesFieldBuilder().getBuilder(index);
    }
    /**
     * <pre>
     * The subdirectories in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.DirectoryNode directories = 2;</code>
     */
    public com.google.devtools.remoteexecution.v1test.DirectoryNodeOrBuilder getDirectoriesOrBuilder(
        int index) {
      if (directoriesBuilder_ == null) {
        return directories_.get(index);  } else {
        return directoriesBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     * <pre>
     * The subdirectories in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.DirectoryNode directories = 2;</code>
     */
    public java.util.List<? extends com.google.devtools.remoteexecution.v1test.DirectoryNodeOrBuilder> 
         getDirectoriesOrBuilderList() {
      if (directoriesBuilder_ != null) {
        return directoriesBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(directories_);
      }
    }
    /**
     * <pre>
     * The subdirectories in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.DirectoryNode directories = 2;</code>
     */
    public com.google.devtools.remoteexecution.v1test.DirectoryNode.Builder addDirectoriesBuilder() {
      return getDirectoriesFieldBuilder().addBuilder(
          com.google.devtools.remoteexecution.v1test.DirectoryNode.getDefaultInstance());
    }
    /**
     * <pre>
     * The subdirectories in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.DirectoryNode directories = 2;</code>
     */
    public com.google.devtools.remoteexecution.v1test.DirectoryNode.Builder addDirectoriesBuilder(
        int index) {
      return getDirectoriesFieldBuilder().addBuilder(
          index, com.google.devtools.remoteexecution.v1test.DirectoryNode.getDefaultInstance());
    }
    /**
     * <pre>
     * The subdirectories in the directory.
     * </pre>
     *
     * <code>repeated .google.devtools.remoteexecution.v1test.DirectoryNode directories = 2;</code>
     */
    public java.util.List<com.google.devtools.remoteexecution.v1test.DirectoryNode.Builder> 
         getDirectoriesBuilderList() {
      return getDirectoriesFieldBuilder().getBuilderList();
    }
    private com.google.protobuf.RepeatedFieldBuilderV3<
        com.google.devtools.remoteexecution.v1test.DirectoryNode, com.google.devtools.remoteexecution.v1test.DirectoryNode.Builder, com.google.devtools.remoteexecution.v1test.DirectoryNodeOrBuilder> 
        getDirectoriesFieldBuilder() {
      if (directoriesBuilder_ == null) {
        directoriesBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
            com.google.devtools.remoteexecution.v1test.DirectoryNode, com.google.devtools.remoteexecution.v1test.DirectoryNode.Builder, com.google.devtools.remoteexecution.v1test.DirectoryNodeOrBuilder>(
                directories_,
                ((bitField0_ & 0x00000002) == 0x00000002),
                getParentForChildren(),
                isClean());
        directories_ = null;
      }
      return directoriesBuilder_;
    }
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFieldsProto3(unknownFields);
    }

    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:google.devtools.remoteexecution.v1test.Directory)
  }

  // @@protoc_insertion_point(class_scope:google.devtools.remoteexecution.v1test.Directory)
  private static final com.google.devtools.remoteexecution.v1test.Directory DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new com.google.devtools.remoteexecution.v1test.Directory();
  }

  public static com.google.devtools.remoteexecution.v1test.Directory getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<Directory>
      PARSER = new com.google.protobuf.AbstractParser<Directory>() {
    public Directory parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
        return new Directory(input, extensionRegistry);
    }
  };

  public static com.google.protobuf.Parser<Directory> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<Directory> getParserForType() {
    return PARSER;
  }

  public com.google.devtools.remoteexecution.v1test.Directory getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

