// Copyright 2015 The Bazel Authors. All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package com.google.devtools.build.java.bazel;

import javax.tools.JavaCompiler;

/**
 * Command line version of {@link BazelJavaCompiler}, interface-compatible with the {@code javac}
 * command, for use with {@code ant}, for example.
 */
public class BazelJavac {
  public static void main(String[] args) {
    JavaCompiler compiler = BazelJavaCompiler.newInstance();
    System.exit(compiler.run(System.in, System.out, System.err, args));
  }
}
